---
# tasks file for pki
- name: Create namespace
  kubernetes.core.k8s:
    name: "{{ k8s_namespace }}"
    api_version: v1
    kind: Namespace
    apply: true
    validate:
      fail_on_error: true
      strict: true

- name: Get CA cert
  become: true
  ansible.builtin.slurp:
    path: "{{ base_path }}/{{ cert_dir }}/ca.crt"
  register: ca_cert

- name: Get CA key
  become: true
  ansible.builtin.slurp:
    path: "{{ base_path }}/{{ cert_dir }}/private-ca.key"
  register: ca_key

- name: Create root-ca Secret
  kubernetes.core.k8s:
    name: root-ca
    apply: true
    namespace: "{{ k8s_namespace }}"
    definition:
      apiVersion: v1
      kind: Secret
      type: kubernetes.io/tls
      data:
        tls.key: "{{ ca_key.content }}"
        tls.crt: "{{ ca_cert.content }}"
    validate:
      fail_on_error: true
      strict: true

- name: Create ca-issuer
  kubernetes.core.k8s:
    name: ca-issuer
    apply: true
    namespace: "{{ k8s_namespace }}"
    definition:
      apiVersion: cert-manager.io/v1
      kind: Issuer
      metadata:
        name: ca-issuer
      spec:
        ca:
          secretName: root-ca
    validate:
      fail_on_error: true
      strict: true

- name: Create Selfsigned Issuer
  kubernetes.core.k8s:
    name: selfsigned-issuer
    apply: true
    namespace: "{{ k8s_namespace }}"
    definition:
      apiVersion: cert-manager.io/v1
      kind: Issuer
      metadata:
        name: selfsigned-issuer
      spec:
        selfSigned: {}
    validate:
      fail_on_error: true
      strict: true
